OUTPUT_FORMAT("elf32-littlearm", "elf32-bigarm",
	      "elf32-littlearm")
OUTPUT_ARCH(arm)

ENTRY(_start)
SEARCH_DIR(/usr/arm-elf/lib/thumb)
SEARCH_DIR(/usr/lib/gcc-lib/arm-elf/3.0.4/thumb)

MEMORY
{
	internal_memory : ORIGIN = 0x01000000, LENGTH =  0x005800	/*  24 kB - 2 kB reserved for stack */
	mirror_memory   : ORIGIN = 0x01006000, LENGTH =  0x008000	/*  32 kB */
	external_memory : ORIGIN = 0x02000000, LENGTH =  0x070000	/* 448 kB */
	flash_memory    : ORIGIN = 0x03000000, LENGTH =  0x400000	/*   4 MB */
}


SECTIONS
{
    shared_mem :
    {   init.o(.text)
        *_call_via_rX.o(.text)
        *(EXCLUDE_FILE(en_* wl_*) .text)
        *(EXCLUDE_FILE(en_* wl_*) .glue_7t)
        *(EXCLUDE_FILE(en_* wl_*) .glue_7)
        *(EXCLUDE_FILE(en_* wl_*) .rodata)
        *(EXCLUDE_FILE(en_* wl_*) .data)
    } > external_memory AT > external_memory

    begin_shared_mem = ADDR(shared_mem);
    end_shared_mem = ADDR(shared_mem) + SIZEOF(shared_mem);
    load_shared_mem = LOADADDR(shared_mem);

    en_internal_mem :  AT (LOADADDR(shared_mem) + SIZEOF(shared_mem))
    {
        en_except.o(.text)

        en_*(.text)
        en_*(.text.*)
        en_*(.stub)
        en_*(.gnu.warning)
        en_*(.gnu.linkonce.t*)
        en_*(.glue_7t)
        en_*(.glue_7)

        en_*(.rodata)
 		en_*(.rodata.*)
        en_*(.gnu.linkonce.r*)

        en_*(.data)
        en_*(.data.*)
        en_*(.gnu.linkonce.d*)

    } > internal_memory

    begin_en_internal_mem = ADDR(en_internal_mem);
    end_en_internal_mem = ADDR(en_internal_mem) + SIZEOF(en_internal_mem);
    load_en_internal_mem = LOADADDR(en_internal_mem);

    wl_internal_mem ADDR(en_internal_mem) : AT (LOADADDR(en_internal_mem) + SIZEOF(en_internal_mem))
    {
        wl_except.o(.text)
        wl_*(.text)
        wl_*(.glue_7t)
        wl_*(.glue_7)

        wl_*(.rodata)
        wl_*(.data)
    }

    begin_wl_internal_mem = ADDR(wl_internal_mem);
    end_wl_internal_mem = ADDR(wl_internal_mem) + SIZEOF(wl_internal_mem);
    load_wl_internal_mem = LOADADDR(wl_internal_mem);

    en_mirror_mem :  AT (LOADADDR(wl_internal_mem) + SIZEOF(wl_internal_mem))
    {
    } > mirror_memory 

    begin_en_mirror_mem = ADDR(en_mirror_mem);
    end_en_mirror_mem = ADDR(en_mirror_mem) + SIZEOF(en_mirror_mem);
    load_en_mirror_mem = LOADADDR(en_mirror_mem);

    wl_mirror_mem ADDR(en_mirror_mem) : AT (LOADADDR(en_mirror_mem) + SIZEOF(en_mirror_mem))
    {
    }

    begin_wl_mirror_mem = ADDR(wl_mirror_mem);
    end_wl_mirror_mem = ADDR(wl_mirror_mem) + SIZEOF(wl_mirror_mem);
    load_wl_mirror_mem = LOADADDR(wl_mirror_mem);


    zi_shared_mem ADDR(shared_mem) + SIZEOF(shared_mem) :
    {   *(EXCLUDE_FILE(en_* wl_*) .bss)
    }

    begin_zi_shared_mem = ADDR(zi_shared_mem);
    end_zi_shared_mem = ADDR(zi_shared_mem) + SIZEOF(zi_shared_mem);

    zi_en_internal_mem ADDR(en_internal_mem) + SIZEOF(en_internal_mem) :
    {   en_*(.dynbss)
        en_*(.bss)
        en_*(.bss.*)
        en_*(COMMON)
    }

    begin_zi_en_internal_mem = ADDR(zi_en_internal_mem);
    end_zi_en_internal_mem = ADDR(zi_en_internal_mem) + SIZEOF(zi_en_internal_mem);

    zi_wl_internal_mem ADDR(wl_internal_mem) + SIZEOF(wl_internal_mem) :
    {   wl_*(.dynbss)
        wl_*(.bss)
        wl_*(.bss.*)
        wl_*(COMMON)
    }

    begin_zi_wl_internal_mem = ADDR(zi_wl_internal_mem);
    end_zi_wl_internal_mem = ADDR(zi_wl_internal_mem) + SIZEOF(zi_wl_internal_mem);

    zi_en_mirror_mem ADDR(en_mirror_mem) + SIZEOF(en_mirror_mem) :
    {
    }

    begin_zi_en_mirror_mem = ADDR(zi_en_mirror_mem);
    end_zi_en_mirror_mem = ADDR(zi_en_mirror_mem) + SIZEOF(zi_en_mirror_mem);

    zi_wl_mirror_mem ADDR(wl_mirror_mem) + SIZEOF(wl_mirror_mem) :
    {
    }

    begin_zi_wl_mirror_mem = ADDR(zi_wl_mirror_mem);
    end_zi_wl_mirror_mem = ADDR(zi_wl_mirror_mem) + SIZEOF(zi_wl_mirror_mem);



  /* Stabs debugging sections.  */
  .stab 0 : { *(.stab) }
  .stabstr 0 : { *(.stabstr) }
  .stab.excl 0 : { *(.stab.excl) }
  .stab.exclstr 0 : { *(.stab.exclstr) }
  .stab.index 0 : { *(.stab.index) }
  .stab.indexstr 0 : { *(.stab.indexstr) }
  .comment 0 : { *(.comment) }
  /* DWARF debug sections.
     Symbols in the DWARF debugging sections are relative to the beginning
     of the section so we begin them at 0.  */
  /* DWARF 1 */
  .debug          0 : { *(.debug) }
  .line           0 : { *(.line) }
  /* GNU DWARF 1 extensions */
  .debug_srcinfo  0 : { *(.debug_srcinfo) }
  .debug_sfnames  0 : { *(.debug_sfnames) }
  /* DWARF 1.1 and DWARF 2 */
  .debug_aranges  0 : { *(.debug_aranges) }
  .debug_pubnames 0 : { *(.debug_pubnames) }
  /* DWARF 2 */
  .debug_info     0 : { *(.debug_info) }
  .debug_abbrev   0 : { *(.debug_abbrev) }
  .debug_line     0 : { *(.debug_line) }
  .debug_frame    0 : { *(.debug_frame) }
  .debug_str      0 : { *(.debug_str) }
  .debug_loc      0 : { *(.debug_loc) }
  .debug_macinfo  0 : { *(.debug_macinfo) }
  /* SGI/MIPS DWARF 2 extensions */
  .debug_weaknames 0 : { *(.debug_weaknames) }
  .debug_funcnames 0 : { *(.debug_funcnames) }
  .debug_typenames 0 : { *(.debug_typenames) }
  .debug_varnames  0 : { *(.debug_varnames) }
}

NOCROSSREFS (en_internal_mem wl_internal_mem)
NOCROSSREFS (en_mirror_mem wl_mirror_mem)

